// ==UserScript==
// @name        Image Alt to Title Attributes Multipopup PreRun Module Modification
// @namespace   http://www.scss.com.au/family/andrew/opera/userjs/
// @version     1.1c
// @date        2005-08-17
// @author      Andrew Gregory <andrew at scss dot com dot au>
// @description Copies image alt attributes to the title (for tooltips)- Multipopup Prerun Module Modification of original script by Andrew Gregory, modified by Hesido.
// @include     *
// ==/UserScript==
// License:     http://creativecommons.org/licenses/by-nc-sa/2.0/
// Notes:       Does not replace an existing title attribute. If the image
//              doesn't have alt text, it is given a single character (an 'X' in
//              a circle).
//              This is a slight modification for the script to run as a Multipopup module.


if (typeof(mpUSRJS) == "undefined") mpUSRJS = new Array();
if (typeof(mpUSRJS.preRunModules) == "undefined") mpUSRJS.preRunModules = new Array();

mpUSRJS.preRunModules[mpUSRJS.preRunModules.length] = function() {
	  var i, imgs, fix = function(img) {
		if (img.hasAttribute('alt')) {
		  if (!img.hasAttribute('title')) {
			img.setAttribute('title', img.getAttribute('alt'));
		  }
		}
	  };
	  imgs = document.getElementsByTagName('img');
	  for (i = 0; i < imgs.length; i++) fix(imgs[i]);
	  imgs = document.getElementsByTagName('input');
	  for (i = 0; i < imgs.length; i++) {
		if (imgs[i].hasAttribute('type') && imgs[i].getAttribute('type').toLowerCase() == 'image') fix(imgs[i]);
	  }
//	  alert('finito');
	}


