// ==UserScript==
// @name        MultiPopup External Preferences File
// @namespace   http://www.hesido.com
// @version     2009
// @date        2005-09-03
// @author      Emrah BASKAYA <emrahbaskaya at hesido dot com>
// @description External Preferences File for Multipopup V2
// @include     *
// ==/UserScript==

/*
When this file is placed in your User Javascript
directory or installed as a GreaseMonkey Script,
the settings here will have precedence
over the internal script settings if this file's
version is above the minimum required preferences
version.
*/
//Do not change the following two lines
if (typeof(mpUSRJS) == "undefined") mpUSRJS = new Array;
mpUSRJS.prefsVersion = '2009';

mpUSRJS.setMPPrefsExternal = function()
{
mpUSRJS.useDefStyle = true;
// true to use default styling embedded, if you are not using an external css.
mpUSRJS.popupDelay = 650;
// delay the popup will show in miliseconds.
mpUSRJS.hideDelay = 85;
// delay the popup window will be closed in miliseconds. This is when warping happens.
mpUSRJS.instPopDur = 370;
// miliseconds to allow instant popup once a popup is displayed;
mpUSRJS.xOfst = 15;
// horizontal offset from mouse pointer
mpUSRJS.yOfst = 15;
// vertical offset from mouse pointer
mpUSRJS.maxTooltipWidth = 320;
// maximum allowed width for the popup in pixels. useDefStyle has to be 'true' for this to work.
mpUSRJS.attDesc = ['href','alt','src','title'];
// the attribute names that contain popup information.
mpUSRJS.attDUse = [true,true,true,true];
// turn support for attribute on or off, one for each.
mpUSRJS.attDPri = [false,false,false,true];
// View in Primary Popup View?
mpUSRJS.attDSec = [true,true,true,false];
// View in Secondary Popup view? (Secondary view is activated by pressing 'control')
mpUSRJS.setAttNull = [false,false,false,false];
// set attribute to null? A "true" setting is not recommended for src, and href's.
mpUSRJS.attDInhrt = [true,false,false,true];
// if immediate parent has this attribute but the actual element has not, inherit from it.
mpUSRJS.forceWordWrap = [true, false, true, false];
// use forced word wrap for the attribute. 'false' is recommended for alt and title
mpUSRJS.stnClass = 'mpop_cl';
// standard class for div and span of the attribute display.
mpUSRJS.alrtClass = 'mpop_al';
// alerted class for div and span of the attribure class, when alert pattern is matched.
mpUSRJS.spcClass = ['mpop_href','mpop_alt','mpop_src','mpop_title'];
// specific class per attribute.
mpUSRJS.attDTitle = ['Address:','Alt:','Source:','Title:']
// the title for each attribute
mpUSRJS.alertPattern = [/^(\s*javascript\:)/i,'','','']
// the pattern for alert (regular expressions are accepted.). '' for no pattern searching.
mpUSRJS.alertToPri = false;
// if there is a pattern match for alerting, copy it to primary view even if it is configured for secondary.
mpUSRJS.alertInstant = false;
// if there is a pattern match, display the primary view immediately. Only works if alertToPri is true.
mpUSRJS.attDNAWA = [false,true,false,true];
// When it is the only attribute that is available, do not append the title of the attribute.
mpUSRJS.clipSteps = 12;
// steps required to reveal div, the more, the slower reveal.
mpUSRJS.revStyle = 0;
// 0 for instant, 1 from center to outwards, 2 from left to right, 3 for from left-top to right-bottom.;
mpUSRJS.revInt = 10;
// milisecond intervals the reveal div function will be called.
mpUSRJS.warpSteps = 0;
// steps required to warp between two popups when there is hide delay. 0 for none.
mpUSRJS.preload = true;
// make it false if you do not want to preload BG images.
mpUSRJS.edgeBufferZone = 32;
// The buffer zone width in px to the edge of the window
mpUSRJS.ttipZIndex = "9999";
// default.zIndex for tooltip
mpUSRJS.autoSelfFocus = true;
// Auto-gain focus for correct key press handling. Currently has no effect.
mpUSRJS.forceBreakAt = 29;
// minimum number of chars needed to force a break, is applied to attributes with 'force word wrap' on.
mpUSRJS.brokenChar = '<span class="mpopbrspan">\u00BB</span><br />'
// The string used to note a force wrapped line.
// Please do not use ampersand encodings here, but the \u type unicode encodings, ampersand encodings will not work.
mpUSRJS.allowSuppress = true;
// Allow suppressing by the websites of automatic viewing of primary view;
mpUSRJS.useShiftForSecondary = false;
// Currently has no effect. When supported and enabled, ctrl will suppress popups, while shift will allow viewing of secondary popup.
mpUSRJS.animEaseFactor =  0.333;
// Ease factor for animationa <1 numbers will produce easeout, >1 numbers will produce easein type animations.
mpUSRJS.cacheViews = true;
// For maximum dynamic mode, set this to false, this causes a slightly higher cpu usage when hovering elements.
mpUSRJS.vBoundaryFixOnZoom = false;
// If you use zooming a lot and complaining that the popup is getting lost beneath the bottom, set this to 'true'
// This fix degrades performance. Recommended value: false;
mpUSRJS.hBoundaryFixOnZoom = false;
// Fixes popup going out of side of the window when zoomed. Causes no performance problems, but may cause too narrow boundaries with some
// styles. Recommended value: false;

}


